#!/bin/bash

# Load rules
	# regle desactivation chgt de mot de passe par Ctrl+Alt+Suppr
	gpo-tool policy register 'Utilisateur/Stratégie/Modèles d’administration/Système/Options Ctrl + Alt + Suppr/Désactiver la modification du mot de passe' '{35378EAC-683F-11D2-A89A-00C04FBBCFA2}{D02B1F73-3407-48AE-BA88-E8213C6761F1}' 'Registry.pol' 'User' 'Software\Microsoft\Windows\CurrentVersion\Policies\system;DisableChangePassword;REG_DWORD;4;{value}'
	
	# regle attribution de droits a un compte/groupe pour ajout de stations de travail au domaine
	gpo-tool policy register 'Machine/Stratégie/Paramètres Windows/Paramètres de sécurité/Stratégies locales/Attribution des droits d’utilisateur/Ajouter des stations de travail au domaine' '{827D319E-6EAC-11D2-A4EA-00C04F79F83A}{803E14A0-B4FB-11D0-A0D0-00A0C90F574B}' 'GptTmpl.inf' 'Machine/Microsoft/Windows NT/SecEdit' '[Privilege Rights]\nSeMachineAccountPrivilege = {group}'
	
	# regle d'association d un compte/groupe a un groupe local (stations de travail)
	gpo-tool policy register 'Machine/Stratégie/Paramètres Windows/Paramètres de sécurité/Groupes restreints' '{827D319E-6EAC-11D2-A4EA-00C04F79F83A}{803E14A0-B4FB-11D0-A0D0-00A0C90F574B}' 'GptTmpl.inf' 'Machine/Microsoft/Windows NT/SecEdit' '[Group Membership]\n{group}__Memberof = {sup_group}\n{group}__Members = {sub_group}'


# Get group names
	# recherche de tous les groupes *PCADM
	groups="$(ldbsearch -H /var/lib/samba/private/sam.ldb '(&(objectclass=Group)(cn=*-PCADM))' cn | awk '/cn: / {print $2}')"

	# saisie mot de passe administrator
	read -r -s -p "Password : " password
	
# Create gpo and link them
for group in $groups
do
    # creation gpo "admin_local_*PCADM"
    samba-tool gpo create "admin_local_${group}" -U administrator%$password
	
	# recuperation ID de la gpo
    guid="$(ldbsearch -H /var/lib/samba/private/sam.ldb "(&(objectclass=groupPolicyContainer)(displayName=admin_local_${group}))" cn | awk '/cn: / {print $2}')"
	
	# recuperation de l ou ou se trouve le groupe PCADM
    ou="$(ldbsearch -H /var/lib/samba/private/sam.ldb "(&(objectclass=Group)(cn=$group))" cn | awk '/dn: / {print $2}')"
	
	# recuperation DN du groupe PCADM
    filter="CN=${group},"
	
    # liaison de la gpo 
    samba-tool gpo setlink "${ou#$filter}" $guid -U administrator%$password
	
	# recuperation sid du groupe PCADM
    pcadm_sid="$(ldbsearch -H /var/lib/samba/private/sam.ldb "(&(objectclass=Group)(cn=${group}))" objectsid | awk '/objectSid: / {print $2}')"
	
	# recuperation sid du groupe OUADM (substitution de PCADM par OUADM dans la commande)
    ouadm_sid="$(ldbsearch -H /var/lib/samba/private/sam.ldb "(&(objectclass=Group)(cn=${group/PCADM/OUADM}))" objectsid | awk '/objectSid: / {print $2}')"
	
	# association de la regle admin_local_PCADM à la gpo
    gpo-tool policy add "admin_local_${group}" 'Machine/Stratégie/Paramètres Windows/Paramètres de sécurité/Groupes restreints' -v group:*${pcadm_sid} -v sup_group:'BUILTIN\Administrateurs' -v sub_group:'' -U administrator%$password


	#Permissions pour le groupe " OUADM " sur l'OU " Machines " 
	samba-tool dsacl set --objectdn "OU=Machines,${ou#$filter}" --sddl "(OA;CI;CCDC;{BF967A86-0DE6-11D0-A285-00AA003049E2};;${ouadm_sid})"
	samba-tool dsacl set --objectdn "OU=Machines,${ou#$filter}" --sddl "(OA;CI;CCDC;{BF967AA5-0DE6-11D0-A285-00AA003049E2};;${ouadm_sid})"
	samba-tool dsacl set --objectdn "OU=Machines,${ou#$filter}" --sddl "(OA;CIIO;CCDCLCSWRPWPDTLOCRSDRCWDWO;;{BF967A86-0DE6-11D0-A285-00AA003049E2};${ouadm_sid})"
	samba-tool dsacl set --objectdn "OU=Machines,${ou#$filter}" --sddl "(OA;CIIO;CCDCLCSWRPWPDTLOCRSDRCWDWO;;{BF967AA5-0DE6-11D0-A285-00AA003049E2};${ouadm_sid})"
	
	#Permissions pour le groupe " OUADM " sur l'OU " Hors Amande "
	samba-tool dsacl set --objectdn "OU=Hors Amande,${ou#$filter}" --sddl "(OA;CI;CCDC;{BF967ABA-0DE6-11D0-A285-00AA003049E2};;${ouadm_sid})"
	samba-tool dsacl set --objectdn "OU=Hors Amande,${ou#$filter}" --sddl "(OA;CIIO;CCDCLCSWRPWPDTLOCRSDRCWDWO;;{BF967ABA-0DE6-11D0-A285-00AA003049E2};${ouadm_sid})"
	samba-tool dsacl set --objectdn "OU=Hors Amande,${ou#$filter}" --sddl "(OA;CI;CCDC;{BF967AA5-0DE6-11D0-A285-00AA003049E2};;${ouadm_sid})"
	samba-tool dsacl set --objectdn "OU=Hors Amande,${ou#$filter}" --sddl "(OA;CIIO;CCDCLCSWRPWPDTLOCRSDRCWDWO;;{BF967AA5-0DE6-11D0-A285-00AA003049E2};${ouadm_sid})"
	samba-tool dsacl set --objectdn "OU=Hors Amande,${ou#$filter}" --sddl "(OA;CI;CCDC;{BF967A9C-0DE6-11D0-A285-00AA003049E2};;${ouadm_sid})"
	samba-tool dsacl set --objectdn "OU=Hors Amande,${ou#$filter}" --sddl "(OA;CIIO;CCDCLCSWRPWPDTLOCRSDRCWDWO;;{BF967A9C-0DE6-11D0-A285-00AA003049E2};${ouadm_sid})"
	samba-tool dsacl set --objectdn "OU=Hors Amande,${ou#$filter}" --sddl "(OA;CIIO;RPWP;{BF967A0A-0DE6-11D0-A285-00AA003049E2};{BF967ABA-0DE6-11D0-A285-00AA003049E2};${ouadm_sid})"
	samba-tool dsacl set --objectdn "OU=Hors Amande,${ou#$filter}" --sddl "(OA;CIIO;CR;{00299570-246D-11D0-A768-00AA006E0529};{BF967ABA-0DE6-11D0-A285-00AA003049E2};${ouadm_sid})"
	
	#Permissions pour le groupe " OUADM " sur le groupe OUADM
	samba-tool dsacl set --objectdn "CN=${group/PCADM/OUADM},${ou#$filter}" --sddl "(OA;;RPWP;{BF9679C0-0DE6-11D0-A285-00AA003049E2};;${ouadm_sid})"

	#Permissions pour le groupe " OUADM " sur le groupe PCADM
	samba-tool dsacl set --objectdn "CN=$group,${ou#$filter}" --sddl "(OA;CI;RPWP;{BF9679C0-0DE6-11D0-A285-00AA003049E2};;${ouadm_sid})"

	#Permissions	pour le groupe " OUADM " sur le groupe SRVADM
	samba-tool dsacl set --objectdn "CN=${group/PCADM/SRVADM},${ou#$filter}" --sddl "(OA;CI;RPWP;{BF9679C0-0DE6-11D0-A285-00AA003049E2};;${ouadm_sid})"
	
done
	
# Restrict machine junction to domain to group integrateurs
	# recuperation sid du groupe integrateurs
	integrateurs_sid="$(ldbsearch -H /var/lib/samba/private/sam.ldb "(&(objectclass=Group)(cn=integrateurs))" objectsid | awk '/objectSid: / {print $2}')"
	
	# association de la regle "ajout de stations de travail au domaine" à la gpo
	gpo-tool policy add "Default Domain Controllers Policy" 'Machine/Stratégie/Paramètres Windows/Paramètres de sécurité/Stratégies locales/Attribution des droits d’utilisateur/Ajouter des stations de travail au domaine' -v group:*${integrateurs_sid} -U administrator%$password

# Restrict Ctrl + Alt + Suppr options
	# creation de la gpo
	samba-tool gpo create "Ctrl+Alt+Suppr" -U administrator%$password
	
	# recuperation ID de la gpo
	guid="$(ldbsearch -H /var/lib/samba/private/sam.ldb "(&(objectclass=groupPolicyContainer)(displayName=Ctrl+Alt+Suppr))" cn | awk '/cn: / {print $2}')"
	
	# recuperation DN du domaine (l'OU "Services" sert de repere) 
	filter="$(ldbsearch -H /var/lib/samba/private/sam.ldb '(&(objectclass=OrganizationalUnit)(ou=Services))' cn | awk '/dn: / {print $2}'|cut -d, -f2-)"
	
	# liaison de la gpo au domaine
	samba-tool gpo setlink "$filter" $guid -U administrator%$password
	
	# association de la regle à la gpo
	gpo-tool policy add "Ctrl+Alt+Suppr" 'Utilisateur/Stratégie/Modèles d’administration/Système/Options Ctrl + Alt + Suppr/Désactiver la modification du mot de passe' -v value:1 -U administrator%$password

exit 0
