#!/bin/bash
#Création des comptes dans les groupes listés dans le fichier dont le nom est passé en paramètre

nomfic=$1
ComptesPneamPsin="synchroamande psin"

function TestGroupes
{
Groupes=$(samba-tool group list|grep "\admin-pnesr\|\admin-psin\|\admin-pneam")
    if [ -z  "$Groupes" ]; then
		samba-tool group add admin-psin
		samba-tool group add admin-pnesr
		samba-tool group add admin-pneam
		samba-tool group addmembers integrateurs admin-pnesr
    fi
}

function CreationCompte
{
compte=$1
groupe=$2
existe=$(samba-tool user list|grep $compte)
    if [ -z  "$existe" ]; then
        samba-tool user create $compte password='$eole&123456$'
        samba-tool group addmembers $groupe $compte
    fi
}

#On vérifie que les groupes d'admin existent
TestGroupes

# Création des comptes PNEAM PSIN non liés à des agents
OLDIFS=IFS
IFS=" "
for compte in $ComptesPneamPsin
        do
            if [ ! -z "$compte" ]; then
                echo "on s'occupe du compte non vide"$compte
		    	existe=$(samba-tool user list|grep $compte)
			    if [ -z "$existe" ]; then
                    echo "le compte "$compte "n'existe pas"
				    samba-tool user create $compte
				    samba-tool user setexpiry $compte --noexpiry
			    fi
		   fi
        done
#Création des comptes issus du fichier de conf
echo "création des comptes listés dans le fichier de conf"
if [ ! -z "$1" ]; then
    cat $1 |
        while read compte groupe
        do
            CreationCompte $compte $groupe
        done
        echo "comptes créés"
else
    echo "il faut spécifier en argument le nom du fichier source"
    exit 1
fi
IFS=OLDIFS
exit 0
